
/*    Init contains all routines to initialize the app.
 *
 *    it's pretty much a mess in here because i use lot's of
 *    hidden things in the different classes.
 */

/*    these are global interface elements. they are kept global
 *    since they have to be accessed somewhere else (mostly in callbacks) ..
 */
 
InterfaceElement[] iElements; // interface element tree

MausManager mm; // see maus library, manages mouse events

// containers for the tabs of the main menu at the bottom
InterfaceContainerImpl mainMenuContainer, 
                       timeMenuContainer, 
                       tabMenuContainer, 
                       anymailsMenuContainer, 
                       groupingMenuContainer;

// the slider with which you set the date
CalendarSlider calendarslider;

// grouping tab: "which", "when" and "how" menus
GroupingMenu grpMenuWhen, grpMenuWhich, grpMenuHow;

// the floating info-box with a shadow
ShadowedBox shadowedBox;
PImage mainmenubackL, mainmenubackC, mainmenubackR; // left, center, right menu pieces
int mainmenuWidth = 980;

// upper border of the main menu, needed to know where the anymails can move
int mainMenuY = 0;


/*    makeInterface() is called once in setup() to load and
 *    create the interface elements, set up the listeners and 
 *    do some initial drawing.
 */
 
void makeInterface ()
{
    shadowedBox = new ShadowedBox(-100,-100,10,10,"Foobar");
    
    // the main menu box is not really an element, it's
    // just a green box drawn on stage once at startup
    
    mainmenubackL = loadImage( "_data/interface/mainmenu_back_left.png"   );
    mainmenubackC = loadImage( "_data/interface/mainmenu_back_center.png" );
    mainmenubackR = loadImage( "_data/interface/mainmenu_back_right.png"  );
    
    int mainmenuHeight = mainmenubackC.height;
    int mmX = (width  - mainmenuWidth) / 2;
    int mmY =  height - (mmX > mainmenubackL.height ? mainmenubackL.height/2 : mmX ) + 6  // 6 = shadow height
               - mainmenubackL.height;
    
    mainMenuY = mmY;
    
    
    // MausManager is a mouse manager, that delegates Processings
    // and some Java MouseEvents to all it's listeners
    
    mm = new MausManager(this);
    
    mainMenuContainer = new InterfaceContainerImpl ( mmX, mmY, mainmenuWidth, mainmenuHeight, "mainMenuContainer" );
    
    
    // ----------- timeMenuContainer + elements ---------------
    //println( "Time menu" );
    
    timeMenuContainer = new InterfaceContainerImpl ( mmX + 15, mmY + 13, mainmenuWidth - 30, 40, "timeMenuContainer" );
    mm.registerMausManager( timeMenuContainer, true );
    mainMenuContainer.registerListener(timeMenuContainer);
    
    // calendarslider, the sliding calendar
    
    calendarslider =
        new CalendarSlider ( mmX + 50, mmY + 18, 881, 18, "calendarslider", 
                             applemailreader.date_earliest * (long)1000, 
                             applemailreader.date_latest * (long)1000 );
    timeMenuContainer.registerMausDing( calendarslider );
    
    // previousMonthButton, nextMonthButton
    // the leftmost and right-most arrow-buttons which will roll the calendar by 1 month
    
    PImage monthLeftNormal = loadImage("_data/interface/time/monthslider_left.gif");
    PImage monthLeftOver   = loadImage("_data/interface/time/monthslider_left_over.gif");
    
    ImageButton previousMonthButton = 
        new ImageButton ( mmX + 21, mmY + 18, 13, 17, "previousMonthButton", monthLeftNormal, monthLeftOver );
    previousMonthButton.catchContinuous = true;
    previousMonthButton.callbackDelay = 120;
    previousMonthButton.registerListener( new ButtonListener(){
        void buttonReleased () {
            if ( keyPressed && keyCode == ALT )
                calendarslider.rollMonth(-12);
            else
                calendarslider.rollMonth(-1);
        }
    } );
    timeMenuContainer.registerMausDing( previousMonthButton );
    
    PImage monthRightNormal = loadImage("_data/interface/time/monthslider_right.gif");
    PImage monthRightOver   = loadImage("_data/interface/time/monthslider_right_over.gif");
    
    ImageButton nextMonthButton = 
        new ImageButton ( mmX + mainmenuWidth - 21 - 11, mmY + 18, 13, 17, "nextMonthButton", monthRightNormal, monthRightOver );
    nextMonthButton.catchContinuous = true;
    nextMonthButton.callbackDelay = 120;
    nextMonthButton.registerListener( new ButtonListener(){
        void buttonReleased () {
            if ( keyPressed && keyCode == ALT )
                calendarslider.rollMonth(12);
            else
                calendarslider.rollMonth(1);
        }
    } );
    timeMenuContainer.registerMausDing( nextMonthButton );
    
    // monthDateViewSlider, a container for the two selection-handles below the calendar
    
    ViewSlider monthDateViewSlider = new ViewSlider ( mmX + 21, mmY + 40, mainmenuWidth - 21, 11, "monthDateViewSlider" );
    //timeMenuContainer.registerMausManager( monthDateViewSlider );
    
    // monthDateViewSliderHandleLeft, monthDateViewSliderHandleRight
    // the two selection handles below the calendar.
    // note that the date-text is drawn by the calendarslider
    
    PImage handleBottomNormal = loadImage("_data/interface/time/viewslider_bottom.png");
    PImage handleBottomOver   = loadImage("_data/interface/time/viewslider_bottom_over.png");
    
    ViewSliderHandle monthDateViewSliderHandleLeft = 
        new ViewSliderHandle ( mmX + 45, mmY + 40, 11, 11, "monthDateViewSliderHandleLeft", 0, 886, handleBottomNormal, handleBottomOver, 4, 0 );
    
    monthDateViewSliderHandleLeft.registerListener( new ViewSliderHandleListener(){
        void viewSliderHandleReleased ( Integer _step ) {
            calendarslider.setSelection( _step.intValue(), 0 );
        };
        void viewSliderHandleChanged ( Integer _step ) {
            calendarslider.setSelection( _step.intValue(), 0 );
        };
    } );
    
    timeMenuContainer.registerMausDing( monthDateViewSliderHandleLeft );
    calendarslider.leftHandle = monthDateViewSliderHandleLeft;
    
    ViewSliderHandle monthDateViewSliderHandleRight = 
        new ViewSliderHandle ( mmX + 45, mmY + 40, 11, 11, "monthDateViewSliderHandleRight", 0, 886, handleBottomNormal, handleBottomOver, 10, 1 );
    
    monthDateViewSliderHandleRight.registerListener( new ViewSliderHandleListener(){
        void viewSliderHandleReleased ( Integer _step ) {
            calendarslider.setSelection( _step.intValue(), 1 );
        };
        void viewSliderHandleChanged ( Integer _step ) {
            calendarslider.setSelection( _step.intValue(), 1 );
        };
    } );
    
    monthDateViewSliderHandleRight.registerListener( monthDateViewSliderHandleLeft );
    monthDateViewSliderHandleRight.limitLeft = 5*20;
    monthDateViewSliderHandleLeft.registerListener( monthDateViewSliderHandleRight );
    monthDateViewSliderHandleLeft.limitRight = 9*20;
    
    timeMenuContainer.registerMausDing( monthDateViewSliderHandleRight );
    calendarslider.rightHandle = monthDateViewSliderHandleRight;
    
    monthDateViewSlider.elements = new InterfaceElement[] { monthDateViewSliderHandleLeft, monthDateViewSliderHandleRight };
    
    // dateSliderLeft, dateSliderRight
    // calendar-attached buttons to scroll it
    
    PImage buttonLeftNormal = loadImage("_data/interface/time/dateslider_left.gif");
    PImage buttonLeftOver   = loadImage("_data/interface/time/dateslider_left_over.gif");
    
    ImageButton dateSliderLeft = 
        new ImageButton ( mmX + 37, mmY + 18, 13, 17, "dateSliderLeft", buttonLeftNormal, buttonLeftOver );
    dateSliderLeft.catchContinuous = true;
    dateSliderLeft.registerListener( new ButtonListener(){
        void buttonReleased( ) {
            calendarslider.roll(-1);
        }
    } );
    timeMenuContainer.registerMausDing( dateSliderLeft );
    
    PImage buttonRightNormal = loadImage("_data/interface/time/dateslider_right.gif");
    PImage buttonRightOver   = loadImage("_data/interface/time/dateslider_right_over.gif");
    
    ImageButton dateSliderRight = 
        new ImageButton ( mmX + mainmenuWidth - 37 - 11, mmY + 18, 13, 17, "dateSliderRight", buttonRightNormal, buttonRightOver );
    dateSliderRight.catchContinuous = true;
    dateSliderRight.registerListener( new ButtonListener(){
        void buttonReleased( ) {
            calendarslider.roll(1);
        }
    } );
    timeMenuContainer.registerMausDing( dateSliderRight );
    
    timeMenuContainer.elements = new InterfaceElement[] { previousMonthButton, nextMonthButton, monthDateViewSlider, dateSliderLeft, calendarslider, dateSliderRight};
    
    
    
    // ----------- main menu buttons: TIME, ANYMAILS, GROUPING, ... ---------------
    //println( "Main menu" );
    
    tabMenuContainer = new InterfaceContainerImpl (mmX + 18, mmY + 68, mainmenuWidth - 18, 14, "tabMenuContainer");
    mm.registerMausManager( tabMenuContainer, true );
    
    Button menuButtonTime = new Button( mmX + 21, mmY + 70, 31, 10, "TIME");
    menuButtonTime.selected = true;
    menuButtonTime.registerListener( new ButtonListener (){
        void buttonReleased() { 
            tabMenuContainer.callListeners("deselect"); 
            mainMenuContainer.callListeners("disable");
            timeMenuContainer.enable();
        };
    });
    tabMenuContainer.registerMausDing( menuButtonTime );
    tabMenuContainer.registerListener( menuButtonTime );
    
    
    Button menuButtonAnymails = new Button( mmX + 64, mmY + 70, 60, 10, "ANYMAILS");
    menuButtonAnymails.registerListener( new ButtonListener (){
        void buttonReleased() {  
            tabMenuContainer.callListeners("deselect"); 
            mainMenuContainer.callListeners("disable");
            anymailsMenuContainer.enable();
        };
    });
    tabMenuContainer.registerMausDing( menuButtonAnymails );
    tabMenuContainer.registerListener( menuButtonAnymails );
    
    
    Button menuButtonGrouping = new Button( mmX + 136, mmY + 70, 60, 10, "GROUPING");
    menuButtonGrouping.registerListener( new ButtonListener (){
        void buttonReleased() {  
            tabMenuContainer.callListeners("deselect"); 
            mainMenuContainer.callListeners("disable");
            groupingMenuContainer.enable();
        };
    });
    tabMenuContainer.registerMausDing( menuButtonGrouping );
    tabMenuContainer.registerListener( menuButtonGrouping );
    
    Button menuButtonAbout = new Button( mmX + mainmenuWidth - 53, mmY + 70, 40, 10, "ABOUT");
    menuButtonAbout.registerListener( new ButtonListener (){
        void buttonReleased() {  
            //tabMenuContainer.callListeners("deselect"); 
            //mainMenuContainer.callListeners("disable");
            link( "http://carohorn.de/anymails/" );
        };
    });
    tabMenuContainer.registerMausDing( menuButtonAbout );
    tabMenuContainer.registerListener( menuButtonAbout );
    
    
    tabMenuContainer.elements = new InterfaceElement[] { menuButtonTime, 
                                                          menuButtonAnymails, 
                                                          menuButtonGrouping, 
                                                          /*menuButtonPreferences, */
                                                          menuButtonAbout };
    
    
    // -------------- anymails tab ---------------------
    //println( "Anymails tab" );
    
    anymailsMenuContainer = new InterfaceContainerImpl (mmX + 16, mmY + 16, mainmenuWidth - 32, 34, "anymailsMenuContainer");
    //anymailsMenuContainer.disable();
    mm.registerMausManager( anymailsMenuContainer, true );
    mainMenuContainer.registerListener(anymailsMenuContainer);
    
    
    TextLabel speciesRolloverStatus = new TextLabel( mmX + 20, mmY + 48, 120, 9, "SPECIES" );
    
    
    PImage speciesCheck1Normal = loadImage("_data/interface/anymails/species/friends.png");
    PImage speciesCheck1Over   = loadImage("_data/interface/anymails/species/ia-friends.png");
    
    ImageCheckbox speciesCheck1 = new ImageCheckbox( mmX + 21, mmY + 18, 40, 17, "SPECIES: Family & Friends", speciesCheck1Normal, speciesCheck1Over );
    speciesCheck1.registerListener( new ButtonListener () {
        void buttonReleased() {
            speciesFilter[TYPE_FAMILYFRIENDS] = !speciesFilter[TYPE_FAMILYFRIENDS];
            visibilityChanged = true;
            stateChanged = true;
        };
    });
    anymailsMenuContainer.registerMausDing(speciesCheck1);
    speciesCheck1.registerListener( speciesRolloverStatus );
    
    
    PImage speciesCheck2Normal = loadImage("_data/interface/anymails/species/school.png");
    PImage speciesCheck2Over   = loadImage("_data/interface/anymails/species/ia-school.png");
    
    ImageCheckbox speciesCheck2 = new ImageCheckbox( mmX + 21 + 40, mmY + 18, 40, 17, "SPECIES: School", speciesCheck2Normal, speciesCheck2Over );
    speciesCheck2.registerListener( new ButtonListener () {
        void buttonReleased() { speciesFilter[TYPE_SCHOOL] = !speciesFilter[TYPE_SCHOOL];
            visibilityChanged = true;
            stateChanged = true;
         };
    });
    anymailsMenuContainer.registerMausDing(speciesCheck2);
    speciesCheck2.registerListener( speciesRolloverStatus );
    
    
    PImage speciesCheck3Normal = loadImage("_data/interface/anymails/species/job.png");
    PImage speciesCheck3Over   = loadImage("_data/interface/anymails/species/ia-job.png");
    
    ImageCheckbox speciesCheck3 = new ImageCheckbox( mmX + 21 + 2*40, mmY + 18, 40, 17, "SPECIES: Job", speciesCheck3Normal, speciesCheck3Over );
    speciesCheck3.registerListener( new ButtonListener () {
        void buttonReleased() { speciesFilter[TYPE_JOB] = !speciesFilter[TYPE_JOB]; 
            visibilityChanged = true;
            stateChanged = true;
        };
    });
    anymailsMenuContainer.registerMausDing(speciesCheck3);
    speciesCheck3.registerListener( speciesRolloverStatus );
    
    
    PImage speciesCheck4Normal = loadImage("_data/interface/anymails/species/ecommerce.png");
    PImage speciesCheck4Over   = loadImage("_data/interface/anymails/species/ia-ecommerce.png");
    
    ImageCheckbox speciesCheck4 = new ImageCheckbox( mmX + 21 + 3*40, mmY + 18, 40, 17, "SPECIES: ECommerce", speciesCheck4Normal, speciesCheck4Over );
    speciesCheck4.registerListener( new ButtonListener () {
        void buttonReleased() { speciesFilter[TYPE_ECOMMERCE] = !speciesFilter[TYPE_ECOMMERCE]; 
            visibilityChanged = true;
            stateChanged = true;
        };
    });
    anymailsMenuContainer.registerMausDing(speciesCheck4);
    speciesCheck4.registerListener( speciesRolloverStatus );
    
    
    PImage speciesCheck5Normal = loadImage("_data/interface/anymails/species/unclassified.png");
    PImage speciesCheck5Over   = loadImage("_data/interface/anymails/species/ia-unclassified.png");
    
    ImageCheckbox speciesCheck5 = new ImageCheckbox( mmX + 21 + 4*40, mmY + 18, 40, 17, "SPECIES: Unclassified", speciesCheck5Normal, speciesCheck5Over );
    speciesCheck5.registerListener( new ButtonListener () {
        void buttonReleased() { speciesFilter[TYPE_UNCLASSIFIED] = !speciesFilter[TYPE_UNCLASSIFIED]; 
            visibilityChanged = true;
            stateChanged = true;
        };
    });
    anymailsMenuContainer.registerMausDing(speciesCheck5);
    speciesCheck5.registerListener( speciesRolloverStatus );
    
    
    PImage speciesCheck6Normal = loadImage("_data/interface/anymails/species/spam.png");
    PImage speciesCheck6Over   = loadImage("_data/interface/anymails/species/ia-spam.png");
    
    ImageCheckbox speciesCheck6 = new ImageCheckbox( mmX + 21 + 5*40, mmY + 18, 40, 17, "SPECIES: Spam", speciesCheck6Normal, speciesCheck6Over );
    speciesCheck6.registerListener( new ButtonListener () {
        void buttonReleased() {
            allowJunk = !allowJunk;
            visibilityChanged = true;
            stateChanged = true;
        };
    });
    anymailsMenuContainer.registerMausDing(speciesCheck6);
    speciesCheck6.registerListener( speciesRolloverStatus );
    
    
    TextLabel statusRolloverStatus = new TextLabel( mmX + 311, mmY + 48, 120, 9, "STATUS" );
    
    
    PImage statusCheck1Normal = loadImage("_data/interface/anymails/status/unread.png");
    PImage statusCheck1Over   = loadImage("_data/interface/anymails/status/ia-unread.png");
    
    ImageCheckbox statusCheck1 = new ImageCheckbox( mmX + 311, mmY + 18, 40, 17, "STATUS: Unread", statusCheck1Normal, statusCheck1Over );
    statusCheck1.registerListener( new ButtonListener () {
        void buttonReleased() {
            allowUnread = !allowUnread;
            visibilityChanged = true;
            stateChanged = true;
        };
    });
    anymailsMenuContainer.registerMausDing(statusCheck1);
    statusCheck1.registerListener( statusRolloverStatus );
    
    
    PImage statusCheck2Normal = loadImage("_data/interface/anymails/status/read.png");
    PImage statusCheck2Over   = loadImage("_data/interface/anymails/status/ia-read.png");
    
    ImageCheckbox statusCheck2 = new ImageCheckbox( mmX + 311 + 40, mmY + 18, 40, 17, "STATUS: Read", statusCheck2Normal, statusCheck2Over );
    statusCheck2.registerListener( new ButtonListener () {
        void buttonReleased() {
            allowRead = !allowRead;
            visibilityChanged = true;
            stateChanged = true;
        };
    });
    anymailsMenuContainer.registerMausDing(statusCheck2);
    statusCheck2.registerListener( statusRolloverStatus );
    
    
    PImage statusCheck3Normal = loadImage("_data/interface/anymails/status/responded.png");
    PImage statusCheck3Over   = loadImage("_data/interface/anymails/status/ia-responded.png");
    
    ImageCheckbox statusCheck3 = new ImageCheckbox( mmX + 311 + 2*40, mmY + 18, 40, 17, "STATUS: Responded", statusCheck3Normal, statusCheck3Over );
    statusCheck3.registerListener( new ButtonListener () {
        void buttonReleased() {
            allowAnswered = !allowAnswered;
            visibilityChanged = true;
            stateChanged = true;
        };
    });
    anymailsMenuContainer.registerMausDing(statusCheck3);
    statusCheck3.registerListener( statusRolloverStatus );
    
    
    anymailsMenuContainer.elements = new InterfaceElement[] { speciesCheck1,
                                                              speciesCheck2,
                                                              speciesCheck3,
                                                              speciesCheck4,
                                                              speciesCheck5,
                                                              speciesCheck6,
                                                              speciesRolloverStatus,
                                                              
                                                              statusCheck1,
                                                              statusCheck2,
                                                              statusCheck3,
                                                              statusRolloverStatus
                                                            };
                                                      
                                                            
    // ------------- groupings menu ------------------
    //println( "Groupings menu" );
    
    groupingMenuContainer = new InterfaceContainerImpl ( mmX + 16, mmY + 16, mainmenuWidth - 32, 34, "groupingMenuContainer" );
    //groupingMenuContainer.disable();
    mm.registerMausManager( groupingMenuContainer, true );
    mainMenuContainer.registerListener(groupingMenuContainer);
    
    
    TextLabel label1 = new TextLabel( mmX + 20 , mmY + 48, 120, 9, "1. METHOD" );
    TextLabel label2 = new TextLabel( mmX + 271, mmY + 48, 120, 9, "2. WHEN" );
    TextLabel label3 = new TextLabel( mmX + 520, mmY + 48, 120, 9, "3. WHICH" );
    TextLabel label4 = new TextLabel( mmX + 768, mmY + 48, 120, 9, "4. HOW" );
    
    PImage imageEnd           = loadImage("_data/interface/grouping/end_arrow.gif");
    PImage menuArrowLeft      = loadImage("_data/interface/grouping/arrow_left.gif");
    PImage menuArrowLeftOver  = loadImage("_data/interface/grouping/arrow_left_over.gif");
    PImage menuArrowRight     = loadImage("_data/interface/grouping/arrow_right.gif");
    PImage menuArrowRightOver = loadImage("_data/interface/grouping/arrow_right_over.gif");
    
    GroupingMenu grpMenuMethod = new GroupingMenu ( mmX + 21, mmY + 18, 192, 17, "grpMenuMethod" );
    grpMenuMethod.imageEnd = imageEnd;
    grpMenuMethod.menuArrowLeft = grpMenuMethod.menuArrowLeftC = menuArrowLeft;
    grpMenuMethod.menuArrowLeftOver = menuArrowLeftOver;
    grpMenuMethod.menuArrowRight = grpMenuMethod.menuArrowRightC = menuArrowRight;
    grpMenuMethod.menuArrowRightOver = menuArrowRightOver;
    grpMenuMethod.choices = new String[] { "KIND: Spacial", 
                                           "KIND: String" };
    grpMenuMethod.images = new PImage[] { loadImage("_data/interface/grouping/meth-spacial.png"),
                                          loadImage("_data/interface/grouping/meth-string.png") };
    grpMenuMethod.registerListener( new GroupingMenuListener() {
        void stateChanged ( Integer _state ) {
            int state = _state.intValue();
            Grouping.METHOD_STATE = state;
            switch ( state )
            {
                case Grouping.METHOD_SPACIAL:
                    grpMenuHow.setEnabled( new boolean[]{true, true, false, false, false} );
                    grpMenuWhen.enabled = false;
                    grpMenuWhich.enabled = false;
                    break;
                default:
                    grpMenuHow.setEnabled( new boolean[]{true, true, true, true, true} );
                    grpMenuWhen.enabled = true;
                    grpMenuWhich.enabled = true;
            }
            stateChanged = true;
        }
    } );
    groupingMenuContainer.registerMausDing(grpMenuMethod);
    
    grpMenuWhen = new GroupingMenu ( mmX + 271, mmY + 18, 192, 17, "grpMenuWhen" );
    grpMenuWhen.imageEnd = imageEnd;
    grpMenuWhen.menuArrowLeft = grpMenuWhen.menuArrowLeftC = menuArrowLeft;
    grpMenuWhen.menuArrowLeftOver = menuArrowLeftOver;
    grpMenuWhen.menuArrowRight = grpMenuWhen.menuArrowRightC = menuArrowRight;
    grpMenuWhen.menuArrowRightOver = menuArrowRightOver;
    grpMenuWhen.choices = new String[] { "GROUP: Continuously", 
                                         "GROUP: On RollOver" };
    grpMenuWhen.images = new PImage[] { loadImage("_data/interface/grouping/when-con.png"),
                                        loadImage("_data/interface/grouping/when-rollover.png") };
    grpMenuWhen.registerListener( new GroupingMenuListener() {
        void stateChanged ( Integer _state ) {
            int state = _state.intValue();
            Grouping.WHEN_STATE = state;
            stateChanged = true;
        }
    });
    groupingMenuContainer.registerMausDing(grpMenuWhen);
    
    grpMenuWhich = new GroupingMenu ( mmX + 520, mmY + 18, 192, 17, "grpMenuWhich" );
    grpMenuWhich.imageEnd = imageEnd;
    grpMenuWhich.menuArrowLeft = grpMenuWhich.menuArrowLeftC = menuArrowLeft;
    grpMenuWhich.menuArrowLeftOver = menuArrowLeftOver;
    grpMenuWhich.menuArrowRight = grpMenuWhich.menuArrowRightC = menuArrowRight;
    grpMenuWhich.menuArrowRightOver = menuArrowRightOver;
    grpMenuWhich.choices = new String[] { "GROUPED BY: Status",
                                          "GROUPED BY: Time",
                                          "GROUPED BY: Species", 
                                          "GROUPED BY: Person" };
    grpMenuWhich.images = new PImage[] { loadImage("_data/interface/grouping/status.png"),
                                         loadImage("_data/interface/grouping/time.png"),
                                         loadImage("_data/interface/grouping/species.png"),
                                         loadImage("_data/interface/grouping/person.png") };
    grpMenuWhich.registerListener( new GroupingMenuListener() {
        void stateChanged ( Integer _state ) {
            int state = _state.intValue();
            Grouping.BY_STATE = state;
            switch ( state ) {
                case Grouping.BY_STATUS: // status -> time, size, species
                    grpMenuHow.setEnabled( new boolean[]{true, false, true, true, false} );
                    break;
                case Grouping.BY_TIME: // time -> status, size, species
                    grpMenuHow.setEnabled( new boolean[]{true, true, false, true, false} );
                    break;
                case Grouping.BY_SPECIES: // species -> time, status, size, person
                    grpMenuHow.setEnabled( new boolean[]{true, true, true, false, true} );
                    break;
                case Grouping.BY_PERSON: // person -> time, status, size
                    grpMenuHow.setEnabled( new boolean[]{true, true, true, false, false} );
                    break;
                default:
                    println( "GroupingMenuListener() // ERROR // bad state: "+ state );
            }
            stateChanged = true;
        }
    });
    groupingMenuContainer.registerMausDing(grpMenuWhich);
    
    grpMenuHow = new GroupingMenu ( mmX + 768, mmY + 18, 192, 17, "grpMenuHow" );
    grpMenuHow.menuArrowLeft = grpMenuHow.menuArrowLeftC = menuArrowLeft;
    grpMenuHow.menuArrowLeftOver = menuArrowLeftOver;
    grpMenuHow.menuArrowRight = grpMenuHow.menuArrowRightC = menuArrowRight;
    grpMenuHow.menuArrowRightOver = menuArrowRightOver;
    grpMenuHow.choices = new String[] { "ARRANGED BY: Size", 
                                        "ARRANGED BY: Status",
                                        "ARRANGED BY: Time", 
                                        "ARRANGED BY: Species",
                                        "ARRANGED BY: Person" };
    grpMenuHow.images = new PImage[] { loadImage("_data/interface/grouping/size.png"),
                                       loadImage("_data/interface/grouping/status.png"),
                                       loadImage("_data/interface/grouping/time.png"),
                                       loadImage("_data/interface/grouping/species.png"),
                                       loadImage("_data/interface/grouping/person.png") };
    grpMenuHow.setEnabled( new boolean[]{true, true, true, true, true} );
    grpMenuHow.registerListener( new GroupingMenuListener() {
        void stateChanged ( Integer _state ) {
            int state = _state.intValue();
            Grouping.ORDER_STATE = state;
            stateChanged = true;
        }
    });
    groupingMenuContainer.registerMausDing(grpMenuHow);
    
    
    groupingMenuContainer.elements = new InterfaceElement[] { label1, label2, label3, label4,
                                                              grpMenuMethod,
                                                              grpMenuWhen,
                                                              grpMenuWhich,
                                                              grpMenuHow
                                                             };
    
    // -------------- add elements to global draw stack
    
    iElements = new InterfaceElement[]{ tabMenuContainer, 
                                        timeMenuContainer, 
                                        anymailsMenuContainer,
                                        groupingMenuContainer
                                       };
}


/*    the three monsters ...
 *
 */

SpriteContainer[][][] gSprites;
FloatContainer[][][]  gMovements;
FloatContainer[][][]  gRotations;

Species[] species;

String[][] speciesAddresses;


/*    loadAnymails() is called after the applemailreader has
 *    fully loaded the SQLite Mail.app database.
 *    it loads the different species plugins and assigns each mail
 *    a species.
 */
 
void loadAnymails ()
{
    /*    data/species/
     *            familie/                           | a species
     *                    1/                         | state unread
     *                        1/                     | young / new
     *                            01.png             | sprites
     *                            ...
     *                            movements.values   | "inner" movements
     *                            rotations.values   | "inner" rotations
     *                        2/
     *                        3/
     *                        4/
     *                        5/                     | old
     *                    2/                         | state read
     *                    3/                         | state answered
     *                    addresses.values           | "name,email" pairs to map email-senders to species
     *            job/
     *            ...
     *
     *
     *    "spam" (as set by Mail.app) and "unclassified" (all non-junk and non-matched)
     *    have no addresses.values
     */
     
     String speciesPath = sketchPath( "_data/species" );
     
     //String[] speciesDirs = getDirectoryContents(dataPath("species"), "^[a-zA-Z0-9]+$");
     
     String[] speciesDirs = getDirectoryContents(
             speciesPath , 
             "^[a-zA-Z0-9]+$"
     );
     
     if ( speciesDirs != null )
     {
             
             gSprites   = new SpriteContainer[speciesDirs.length][0][0];
             gMovements = new FloatContainer [speciesDirs.length][0][0];
             gRotations = new FloatContainer [speciesDirs.length][0][0];
             
             species = new Species[speciesDirs.length];
             speciesAddresses = new String[speciesDirs.length][0];
             speciesFilter = new boolean[speciesDirs.length];
             
         for ( int s = 0; s < speciesDirs.length; s++ )
         {
             speciesFilter[s] = true; // show all by default
             
                  if ( speciesDirs[s].equals("familie") )
                  {
                     TYPE_FAMILYFRIENDS = s;
                     ANYMAIL_COLORS[TYPE_FAMILYFRIENDS] = new int[] {Colors.FAMILYFRIENDS, Colors.FAMILYFRIENDS_MEDIUM, Colors.FAMILYFRIENDS_LIGHT};
                     SPECIES_NAMES[TYPE_FAMILYFRIENDS] = "Family & Friends";
                  }
             else if ( speciesDirs[s].equals("job") )
                  {
                     TYPE_JOB = s;
                     ANYMAIL_COLORS[TYPE_JOB] = new int[] {Colors.JOB, Colors.JOB_MEDIUM, Colors.JOB_LIGHT};
                     SPECIES_NAMES[TYPE_JOB] = "Job";
                  }
             else if ( speciesDirs[s].equals("school") )
                  {
                     TYPE_SCHOOL = s;
                     ANYMAIL_COLORS[TYPE_SCHOOL] = new int[] {Colors.SCHOOL, Colors.SCHOOL_MEDIUM, Colors.SCHOOL_LIGHT};
                     SPECIES_NAMES[TYPE_SCHOOL] = "School";
                  }
             else if ( speciesDirs[s].equals("orders") )
                  {
                     TYPE_ECOMMERCE = s;
                     ANYMAIL_COLORS[TYPE_ECOMMERCE] = new int[] {Colors.ECOMMERCE, Colors.ECOMMERCE_MEDIUM, Colors.ECOMMERCE_LIGHT};
                     SPECIES_NAMES[TYPE_ECOMMERCE] = "ECommerce";
                  }
             else if ( speciesDirs[s].equals("spam") )
                  {
                     TYPE_SPAM = s;
                     ANYMAIL_COLORS[TYPE_SPAM] = new int[] {Colors.SPAM, Colors.SPAM_MEDIUM, Colors.SPAM_LIGHT};
                     SPECIES_NAMES[TYPE_SPAM] = "Spam";
                  }
             else if ( speciesDirs[s].equals("unclass") )
                  {
                     TYPE_UNCLASSIFIED = s;
                     ANYMAIL_COLORS[TYPE_UNCLASSIFIED] = new int[] {Colors.UNCLASSIFIED, Colors.UNCLASSIFIED_MEDIUM, Colors.UNCLASSIFIED_LIGHT};
                     SPECIES_NAMES[TYPE_UNCLASSIFIED] = "Unclassified";
                  }
             
             String statesDir = speciesPath + File.separator + speciesDirs[s];
             String speciesAddressesPath = statesDir + File.separator + "addresses.values";
             speciesAddresses[s] = loadStrings(speciesAddressesPath);
             
             if ( speciesAddresses[s].length < 5 )
             {
                 System.err.println( "Loader thread: There are almost no email addresses in there (maybe add some):\n\t" + speciesAddressesPath );
             }
             
             String[] states = getDirectoryContents( statesDir, "^[0-9]+$" );
             
             gSprites[s]   = new SpriteContainer[states.length][0];
             gMovements[s] = new FloatContainer [states.length][0];
             gRotations[s] = new FloatContainer [states.length][0];
        
            for ( int st = 0; st < states.length; st++ )
            {
                String agesDir = statesDir + File.separator + states[st];
                
                String[] ages = getDirectoryContents( agesDir, "^[0-9]+$" );
             
                gSprites[s][st]   = new SpriteContainer[ages.length];
                gMovements[s][st] = new FloatContainer [ages.length];
                gRotations[s][st] = new FloatContainer [ages.length];
                
                for ( int ag = 0; ag < ages.length; ag++ )
                {
                    String spritesDir = agesDir + File.separator + ages[ag];
                    
                    String[] sprites = getDirectoryContents( spritesDir, "^[0-9]+\\.png$" );
                    
                    PImage[] imgs = new PImage[sprites.length];
                    
                    for ( int im = 0; im < imgs.length; im++ )
                    {
                        imgs[im] = loadImage( spritesDir +  File.separator + sprites[im] );
                    }
                    gSprites[s][st][ag]   = new SpriteContainer(imgs);
                    
                    String[] movs = loadStrings( spritesDir +  File.separator + "movements.values" );
                    float[] movsf = new float[movs.length];
                    for ( int m = 0; m < movs.length; m++ )
                    {
                        movsf[m] = Float.parseFloat(movs[m]);
                    }
                    gMovements[s][st][ag] = new FloatContainer( movsf );
                    
                    String[] rots = loadStrings( spritesDir +  File.separator + "rotations.values" );
                    float[] rotsf = new float[rots.length];
                    for ( int r = 0; r < rots.length; r++ )
                    {
                        rotsf[r] = Float.parseFloat(rots[r]);
                    }
                    gRotations[s][st][ag] = new FloatContainer(rotsf);
                }
            }
            
            species[s] = new Species ( gSprites[s], gMovements[s], gRotations[s] );
         }
     }
     else error("loadAnymails(): No species found that could be loaded!");
}




/*    connectToAnymails()
 *
 *    map emails to anymails
 */

void connectToAnymails ()
{
    anymails = new Anymail[totalMails.length];
    anymailToEmailId = new Mappable(totalMails.length);
    
    for ( int i = 0; i < totalMails.length; i++ )
    {
        String row = "";
        int type = totalMails[i].is_junk ? TYPE_SPAM : TYPE_UNCLASSIFIED;
        
        if ( !totalMails[i].is_junk )
        {
            for ( int s = 0; s < speciesAddresses.length; s++ )
            {
                if ( s == TYPE_SPAM || s == TYPE_UNCLASSIFIED ) continue;
                for ( int ss = 0; ss < speciesAddresses[s].length; ss++ )
                {
                     if (speciesAddresses[s][ss].toLowerCase().endsWith(
                         applemailreader.addresses[
                                 applemailreader.addressMap.indexForValue(totalMails[i].sender_id)
                                                  ].address.toLowerCase()
                         ))
                     {
                         type = s;
                         row = speciesAddresses[s][ss];
                         break;   
                     }
                }
                if ( type != TYPE_UNCLASSIFIED ) break;
            }
        }
        
        anymails[i] = new Anymail( species[type].clone(), random(100,width-100), random(100,height-200) );
        anymails[i].type = type;
        anymails[i].email = totalMails[i];
        String[] name = split(row,','); anymails[i].name = name[0].equals("") ? "" : name[0];
        anymails[i].setAge( random(1.0) ); // will later be set in relation to current date
        anymails[i].setState( totalMails[i].read ? ( totalMails[i].answered ? 2 : 1 ) : 0  );
        anymailToEmailId.mapIndexToValue( i, totalMails[i].id );
    }
    
    anymailToEmailId.reverse();
}



/*    getDirectoryContents()
 *
 *    read and match contents of a dir and return them in an array.
 */

String[] getDirectoryContents ( String _dir ) { return getDirectoryContents(_dir, null); }

String[] getDirectoryContents ( String _dir, String _filter )
{
    File dir = new File( _dir );
    if ( !dir.isDirectory() || !dir.canRead() ) {
        error( "getDirectoryContents(): Not a dir or not readable: " + _dir );
        return null;
    }
    
    String[] children;
    if ( _filter != null )
        children = dir.list( new RegexFilenameFilter(dir, _filter) );
    else
        children = dir.list();
        
    if (children == null || children.length <= 0 )
    {
        error( "getDirectoryContents(): Nothing in there: " + _dir + ( _filter != null ? " that matches \"" + _filter + "\"" : "" ) );
        return null;
    }
    
    return children;
}


/*    RegexFileFilter
 *
 */

class RegexFilenameFilter
implements FilenameFilter
{
    String absolutePath;
    String filter;
    
    RegexFilenameFilter ( File _dir, String _filter )
    {
        absolutePath = _dir.getAbsolutePath();
        filter = _filter;
    }
    
    boolean accept( File dir, String name ) {
        return (     absolutePath.equals( dir.getAbsolutePath() )
                     &&  name.matches( filter ) );
    }
}


// a callback for the AppleMailReader,
// will be called once it's finished loading

void mailboxesLoaded () {
    initState++;
    
    totalMails = applemailreader.getFilteredMessages(
                        new EmlxFilter( applemailreader.date_earliest, // date from
                                        applemailreader.date_latest, // date to
                                        EmlxFilter.SKIP, // read
                                        EmlxFilter.SKIP, // answered
                                        EmlxFilter.SKIP, // sender id
                                        EmlxFilter.SKIP ), // mailbox id
                                        EmlxFilter.RECEIVED_ONLY,
                                        EmlxFilter.HIDE_DELETED );
    
    println( "AppleMailReader: Loaded: "+totalMails.length+" (received & not deleted) emails." );
}



/* main interface loader thread */

class LoadThread
extends java.lang.Thread
{
    boolean running = false;
    
    LoadThread ( )
    {
        super("AnymailsLoadThread");
    }
    
    public void run ()
    {
        running = true;
        
        while ( initState < 4 )
        {
            long ts = System.currentTimeMillis();
            switch ( initState )
            {
                case 1:
                    makeInterface(); println("Initialized interface: "+((System.currentTimeMillis()-ts)/1000.0));
                    area51 = new Area( 0, 0, width, mainMenuY-5 );
                    area51.singleMode = true; // MausManager: let only one object consume the mouse
                    gridLookUp = new GridLookUp(area51.width, area51.height, 5);
                    initState++;
                    break;
            
                case 2:
                    loadAnymails(); println("Loaded Anymails: "+((System.currentTimeMillis()-ts)/1000.0));
                    initState++;
                    break;
            
                case 3:
                    connectToAnymails(); println("Initialized Anymails: "+((System.currentTimeMillis()-ts)/1000.0));
                    initState++;
                    break;
            }
        }
        
        running = false;
    }
}



 
/*
 *    This work is licensed under a 
 *    Creative Commons Attribution-Noncommercial-Share Alike 3.0 License.
 *    http://creativecommons.org/licenses/by-nc-sa/3.0/
 */
