
/*    in here you'll find (hopefully) any constants 
 *    defined for the project:
 *
 *    - colors
 *    - fonts
 *    - speeds
 *    - forces
 *    - groupings
 *    - timeperiods
 *    - ...
 */
 
class Colors
{
    final static int VIVID_GREEN        = 0xFF9ea21c; // upper menu
    final static int VIVID_LIGHT_GREEN  = 0xFFc9cc86; // menu items light (+ textboxen bei grouping, inactive boxen bei anymails)
    final static int VIVID_MEDIUM_GREEN = 0xFFb4b853; // menu items dark

    final static int DARK_GREEN         = 0xFF707c13; // lower menu
    final static int DARK_MEDIUM_GREEN  = 0xFFb7ba78; // main menu items lower (inactive)

    final static int BEIGE_MEDIUM       = 0xFFe8ead3; // rollover (anymails boxen)
    final static int BEIGE_DARK         = 0xFFd8dbb7; // highlight anymails
    final static int BACKGROUND         = BEIGE_MEDIUM;

    final static int GREY_DARK          = 0xFF3a3a30; // type on stage, type in calendar

    final static int WHITE              = 0xFFFFFFFF; // rollover slider
    final static int BLACK              = 0xFF000000;
    
    final static int JOB                = 0xFFb76800;
    final static int JOB_MEDIUM         = 0xFFc27f26;
    final static int JOB_LIGHT          = 0xFFcc954c;
    
    final static int ECOMMERCE          = 0xFF9e2900;
    final static int ECOMMERCE_MEDIUM   = 0xFFac4926;
    final static int ECOMMERCE_LIGHT    = 0xFFbb694c;
    
    final static int FAMILYFRIENDS        = 0xFF9ea21c;
    final static int FAMILYFRIENDS_MEDIUM = 0xFFacb03e;
    final static int FAMILYFRIENDS_LIGHT  = 0xFFbbbe60;
    
    final static int SCHOOL             = 0xFF14647a;
    final static int SCHOOL_MEDIUM      = 0xFF377b8e;
    final static int SCHOOL_LIGHT       = 0xFF5a92a2;
    
    final static int UNCLASSIFIED         = 0xFF5a6003;
    final static int UNCLASSIFIED_MEDIUM  = 0xFF737829;
    final static int UNCLASSIFIED_LIGHT   = 0xFF8b8f4e;
    
    final static int SPAM               = 0xFF514e2e;
    final static int SPAM_MEDIUM        = 0xFF6b684d;
    final static int SPAM_LIGHT         = 0xFF85836c;
    
    final static int BOX_SHADOW    = 0x00727154;
}

static int ANYMAIL_COLORS[][] = new int[6][3];
static String SPECIES_NAMES[] = new String[6];
static String STATES_NAMES[] = new String[]{"Unread", "Read", "Responded"};

// states of the grouping menu tab
static class Grouping
{
    final static int METHOD_SPACIAL = 0;
    final static int METHOD_STRING = 1;
    static int METHOD_STATE = METHOD_STRING;

    final static int WHEN_CONTINOUSLY = 0;
    final static int WHEN_ROLLOVER = 1;
    static int WHEN_STATE = WHEN_ROLLOVER;

    final static int BY_STATUS = 0;
    final static int BY_TIME = 1;
    final static int BY_SPECIES = 2;
    final static int BY_PERSON = 3;
    static int BY_STATE = BY_TIME;

    final static int ORDER_SIZE = 0;
    final static int ORDER_STATUS = 1;
    final static int ORDER_TIME = 2;
    final static int ORDER_SPECIES = 3;
    final static int ORDER_PERSON = 4;
    static int ORDER_STATE = ORDER_STATUS;
}

final static int STROKE_WEIGHT  = 10;

class Speeds
{
    final static float SLOW     = 0.05;
    final static float MEDIUM   = 0.7;
    final static float FAST     = 2.7;
    final static float PANIC    = 5.6;
}

class Forces
{
    final static float ANTIGRAVITY  = 0.25;   // behaves like an anti-gravity: the closer the object and
                                              // the smaller the value, the harder they are pushed away.
                                              
    final static float ANITFRICTION = 0.90;   // how much a force declines per frame: 1.0 -> do not decline,
                                              // 0.5 -> half the force remains, 0.0 -> no force stays
}

PFont REGULAR_8;
PFont REGULAR_9, BOLD_9;
PFont REGULAR_10, BOLD_10;
PFont REGULAR_12, BOLD_12;
PFont BOLD_14;

void loadFonts ()
{
    REGULAR_8     = loadFont( "_data/fonts/LucidaGrande-8.vlw" );
    
    REGULAR_9     = loadFont( "_data/fonts/LucidaGrande-9.vlw" );
    BOLD_9        = loadFont( "_data/fonts/LucidaGrande-Bold-9.vlw" );
    
    REGULAR_10    = loadFont( "_data/fonts/LucidaGrande-10.vlw" );
    BOLD_10       = loadFont( "_data/fonts/LucidaGrande-Bold-10.vlw" ); 
    
    REGULAR_12    = loadFont( "_data/fonts/LucidaGrande-12.vlw" );
    BOLD_12       = loadFont( "_data/fonts/LucidaGrande-Bold-12.vlw" );   
    
    BOLD_14       = loadFont( "_data/fonts/LucidaGrande-Bold-14.vlw" );  
}

class Timeperiod
{
    final static long SECOND = (long)1000;
    final static long MINUTE = Timeperiod.SECOND*(long)60;
    final static long HOUR   = Timeperiod.MINUTE*(long)60;
    final static long DAY    = Timeperiod.HOUR*(long)24;
}



 
/*
 *    This work is licensed under a 
 *    Creative Commons Attribution-Noncommercial-Share Alike 3.0 License.
 *    http://creativecommons.org/licenses/by-nc-sa/3.0/
 */
