
void error ( String _err )
{
    System.err.println( " // ERROR // " + _err );
}

/*    Thick lines for P3D or OPENGL.
 *    See: http://dev.processing.org/bugs/show_bug.cgi?id=123
 */
 
void thickLine( float x1, float y1, float x2, float y2 )
{
    float ox1 = x1; float oy1 = y1;
    float ox2 = x2; float oy2 = y2;

    float dX = ox2-ox1 + 0.0001f;
    float dY = oy2-oy1 + 0.0001f;
    float len = fastSqrt(dX*dX + dY*dY);

    float rh = g.strokeWeight / 2.0 / len;
    int fillO = g.fillColor;
    fill( g.strokeColor );
    noStroke();
    

    float dx0 = rh * dY;
    float dy0 = rh * dX;

    beginShape(QUADS);

        vertex(ox1+dx0, oy1-dy0);
        vertex(ox1-dx0, oy1+dy0);

        vertex(ox2-dx0, oy2+dy0);
        vertex(ox2+dx0, oy2-dy0);

    endShape(CLOSE);
    
    fill( fillO );
}


// http://en.wikipedia.org/wiki/Methods_of_computing_square_roots
public static float fastSqrt (float val)
{

    float xhalf = 0.5f*val;
    int i = Float.floatToIntBits(val);
    i = 0x5f3759df - (i >> 1);
    val = Float.intBitsToFloat(i);
    return 1.0f/(val * (1.5f - xhalf * val * val));
}
    
public static float fastDist (float x1, float y1, float x2, float y2)
{
    float dx = x2-x1; float dy = y2-y1;
    return fastSqrt(dx*dx + dy*dy);
}

// http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=6349911
public static double fastPow (final double x, final double y)
{
    final int yi = (int) y;
    if (y - yi == 0 && yi > 0) {
        double result = x;
        for (int i = 2; i <= yi; i++) result *= x;
        return result;
    }
    else
        return Math.pow(x, y);
}



 
/*
 *    This work is licensed under a 
 *    Creative Commons Attribution-Noncommercial-Share Alike 3.0 License.
 *    http://creativecommons.org/licenses/by-nc-sa/3.0/
 */
